% this script shows the usage of JointMC1.m
% demo
clear;
% =========================================================================
% file_name='C:\Documents and Settings\Qiang.MADDY\My Documents\Matlab\matrix completion\Lobby.m1v';
% fstart=51;
% fend=200;
% X=movie2mat(file_name, fstart, fend);
% X=double(X);
% % set up parameters
% N=fend-fstart+1;
% =========================================================================
% for image case
% for AR
path='F:\MATLAB\AR\';
dirlist=dir([path 'M-001*.bmp']);
% path=[];
% dirlist=dir('*.tif');
N=length(dirlist);
X=[];
for i=1: N
    img=imread([path dirlist(i).name]);
    img=imresize(img, [55, 40]);
    height=size(img, 1);
    width=size(img, 2);
    % color image?
    if size(img, 3)~=1
        X=[X 0.2989*img(:, :, 1)+0.5870*img(:, :, 2)+0.1140*img(:, :, 3)];
    else
        X=[X img];
    end
    % some preprocessing may be need here
end
X=double(X);
% =========================================================================
% lambda=1/sqrt(size(X, 1));
% use a smaller weight for sparisity term
lambda=0.75/sqrt(size(X, 1));
tol=1e-6;
maxIter=100;
limem=1;
% start program
[C_hat, A_hat, E_hat, output]=JointMC4(X, N, lambda, tol, maxIter, limem, 1, 0, 1.25, 1.5);
% =========================================================================
% row=1;
% column=4;
% img=zeros(height*row, width*column);
% for irow=1:row
%     img((irow-1)*height+1: irow*height, :)=reshape(X(:, (irow-1)*column+1: irow*column), height, []);
% end
% matrix2im(img, ['AR' datestr(now, '-yy-mm-dd-HH-MM-SS-') 'X.tif'], 8);
% matrix2im(reshape(C_hat, height, []), ['AR' datestr(now, '-yy-mm-dd-HH-MM-SS-') 'C.tif'], 8);
% img=zeros(height*row, width*column);
% for irow=1:row
%     img((irow-1)*height+1: irow*height, :)=reshape(E_hat(:, (irow-1)*column+1: irow*column), height, []);
% end
% matrix2im(abs(img), ['AR'  datestr(now, '-yy-mm-dd-HH-MM-SS-') 'E.tif'], 8);
% img=zeros(height*row, width*column);
% for irow=1:row
%     img((irow-1)*height+1: irow*height, :)=reshape(A_hat(:, (irow-1)*column+1: irow*column), height, []);
% end
% matrix2im(img, ['AR'  datestr(now, '-yy-mm-dd-HH-MM-SS-') 'A.tif'], 8);
% clear irow img;
% save([datestr(now, 'yy-mm-dd-HH-MM-SS-') 'AR.mat']);
% =========================================================================
% save result
% save([file_name(1:end-4) datestr(now, '-yy-mm-dd-HH-MM-SS-') sprintf('%04d-%04d.mat', fstart, fend)]);
% save to movie
% data={reshape(X, 128, 160, 150) repmat(C_hat, [1, 1, 150]) reshape(A_hat, 128, 160, 150) reshape(abs(E_hat), 128, 160, 150)};
% mat2movie(data, [file_name(1:end-4) datestr(now, '-yy-mm-dd-HH-MM-SS-') sprintf('%04d-%04d.avi', fstart, fend)]);