% This file encode the sparse part in gross innovation
% some issues with AR dataset, since we only return 13 conditions for E_hat
function E_tmp=DecodeInnovation(Gi, Gj, option)
if strcmpi(option.dataset, 'AR')
    E_tmp=zeros(option.height*option.n_People, option.width*option.n_Condition/2);
    for i=1: option.n_People/2
        for j=1: option.n_Condition/2
            E_tmp(option.height*(i-1)+1: option.height*i, option.width*(j-1)+1: option.width*j)=...
                ThreshJSM(Gi(:, (i-1)*option.width+1: option.width*i), ...
                Gj(:, (j-1)*option.width+1: option.width*j));
        end
    end
    for i=option.n_People/2+1: option.n_People
        for j=option.n_Condition/2+1: option.n_Condition
            E_tmp(option.height*(i-1)+1: option.height*i, option.width*(j-14)+1: option.width*(j-13))=...
                ThreshJSM(Gi(:, (i-1)*option.width+1: option.width*i), ...
                Gj(:, (j-1)*option.width+1: option.width*j));
        end
    end
elseif strcmpi(option.dataset, 'YaleB')
    E_tmp=zeros(option.height*option.n_People, option.width*option.n_Condition);
    for i=1: option.n_People
        for j=1: option.n_Condition
            E_tmp(option.height*(i-1)+1: option.height*i, option.width*(j-1)+1: option.width*j)=...
                ThreshJSM(Gi(:, (i-1)*option.width+1: option.width*i), ...
                Gj(:, (j-1)*option.width+1: option.width*j));
        end
    end
end
