% V2:       we use sum to replace mean
% This file encode the sparse part in gross innovation
function [Gi, Gj]=EncodeInnovation(E_hat, option)
if strcmpi(option.dataset, 'AR')
    Gi=zeros(option.height, option.width*option.n_Condition);
    Gj=zeros(option.height, option.width*option.n_People);
    tmp1=option.n_People*option.height/2;
    tmp2=option.n_Condition/2;
    for i=1: option.n_People/2
        for j=1: option.n_Condition/2
            Gi(:, (i-1)*option.width+1: option.width*i)=...
                reshape(sum(reshape(E_hat(option.height*(i-1)+1: option.height*i, :), ...
                option.height*option.width, []), 2), option.height, option.width);
            Gj(:, (j-1)*option.width+1: option.width*j)=...
                reshape(sum(reshape(E_hat(1: tmp1, option.width*(j-1)+1: option.width*j)', ...
                option.height*option.width, []), 2), option.width, option.height)';
        end
    end
    for i=option.n_People/2+1: option.n_People
        for j=option.n_Condition/2+1: option.n_Condition
            Gi(:, (i-1)*option.width+1: option.width*i)=...
                reshape(sum(reshape(E_hat(option.height*(i-1)+1: option.height*i, :), ...
                option.height*option.width, []), 2), option.height, option.width);
            Gj(:, (j-1)*option.width+1: option.width*j)=...
                reshape(sum(reshape(E_hat(tmp1+1: end, option.width*(j-tmp2-1)+1: option.width*(j-tmp2))', ...
                option.height*option.width, []), 2), option.width, option.height)';
        end
    end
elseif strcmpi(option.dataset, 'YaleB')
    Gi=zeros(option.height, option.width*option.n_Condition);
    Gj=zeros(option.height, option.width*option.n_People);
    for i=1: option.n_People
        for j=1: option.n_Condition
            Gi(:, (i-1)*option.width+1: option.width*i)=...
                reshape(sum(reshape(E_hat(option.height*(i-1)+1: option.height*i, :), ...
                option.height*option.width, []), 2), option.height, option.width);
            Gj(:, (j-1)*option.width+1: option.width*j)=...
                reshape(sum(reshape(E_hat(:, option.width*(j-1)+1: option.width*j)', ...
                option.height*option.width, []), 2), option.width, option.height)';
        end
    end
end