% learn 2 component mixture gaussian model
function [mu, sigma, prob, thresh]=LearnGMM(data)
tol=1e-2;
thresh=mean([max(data) min(data)]);
while 1
    % up
    tmp=data(data>=thresh);
    P1=length(tmp);
    mu(1)=mean(tmp);
    sigma(1)=var(tmp);
    % low
    tmp=data(data<thresh);
    P2=length(tmp);
    mu(2)=mean(tmp);
    sigma(2)=var(tmp);
    % estimate the thresh
    tmp=mean(mu)+mean(sigma)/(mu(1)-mu(2))*log(P2/P1);
%     if sigma(1)<sigma(2)
%         tmp=((mu(2)*sigma(1)-mu(1)*sigma(2))+...
%             sqrt(sigma(1)*sigma(2)*((mu(1)-mu(2))^2+2*(sigma(2)-sigma(1))*log((sqrt(sigma(2)/sigma(1))*(P1/P2))))))/...
%             (sigma(1)-sigma(2));
%     else
%         tmp=((mu(2)*sigma(1)-mu(1)*sigma(2))-...
%             sqrt(sigma(1)*sigma(2)*((mu(1)-mu(2))^2+2*(sigma(2)-sigma(1))*log((sqrt(sigma(2)/sigma(1))*(P1/P2))))))/...
%             (sigma(1)-sigma(2));
%     end
    if abs(tmp-thresh)/abs(thresh)<tol
        break;
    else
        thresh=tmp;
    end
end
thresh=tmp;
prob=[P1, P2];