% SplitARDatabase
% split the the YaleB database into training sets (32) and test (left) sets as SRC
% get a dir list of all images of type 'imagetype'
try
    cd('test');
    cd('..');
catch
    mkdir('test');
end
try
    cd('test');
    movefile('*.jpg', '..\test');
end
cd('..');
no_people=68;
no_image=153;
% no_test=no_image-21;
no_test=no_image-40;
mode=0;
if mode==1
    eval( sprintf('dirlist=dir(''*.%s'');', 'jpg' ) ); 
    j=0;
    index=zeros(1, no_test);
    i=randperm(no_image);
    while 1;
        if j==no_people
            break;
        end
        % select the order
        index=j*no_image+i(1:no_test);
        for k=1:no_test
            movefile(dirlist(index(k)).name, 'test');
        end
        j=j+1;
    end
else
    no_test_set=floor(no_test/7);
    prefix={'*illum_05*.jpg', '*illum_07*.jpg', '*illum_09*.jpg',...
        '*illum_27*.jpg', '*illum_29*.jpg', '*light_05*.jpg',...
        '*light_27*.jpg'};
    for l=1: length(prefix)
        j=0;
        dirlist=dir(prefix{l});
        no_image_set=length(dirlist)/no_people;
        i=randperm(no_image_set);
        while 1;
            if j==no_people
                break;
            end
            % select the order
            % i=randperm(no_image);
            index=j*no_image_set+i(1:no_test_set);
            for k=1: no_test_set
                movefile(dirlist(index(k)).name, 'test');
            end
            j=j+1;
        end
    end
end