% this function writes the data into image
function img=matrix2im(data, file_name, bits)
% depth
if bits==8
    maxval=255;
else
    maxval=65535;
end
% re-range the data matrix
up=max(data(:));
lo=min(data(:));
img=(data-lo)*maxval/(up-lo);
% write the image
if bits==8
    img=uint8(img);
else
    img=uint16(img);
end
if ~isempty(file_name)
    imwrite(img, file_name);
end